// plugin script :
displayname="Google Translate";
versionstring="1.0.0";
releasedatestring="30.1.2008";
author="Oldrich Svec";
updateurl="";
homepageurl="";
shortdescription="Google Translate";
longdescription="This plugin uses http://translate.google.com/.";
advconfigstring="Google Translate";
readmestring="Google Translate";
iconfilename="favicon.ico";

aliasstr="gt";
regexstr="^gt (\\w{2}) (\\w{2}) (.*) $";
scriptregex=/^gt (\w{2}) (\w{2}) (.*) $/;
scriptregex2=/^gt \w{2} \w{2} .* .*$/;
regexfilterstr="";
keywordstr="";
scorestr="300";

// type
UNKNOWN=0; FILE=1; FOLDER=2; ALIAS=3; URL=4; PLUGIN=5; CLIP=5;
// Postprocessing
IMMEDIATE_DISPLAY=0; ADDSCORE=1; MATCH_AGAINST_SEARCH=2;
// search state
STOPPED=0; SEARCHING=1;

var pre_results, output;

function doQuery(querykey,querynokeyword,from_lang,to_lang){
    var url = "http://translate.google.com/translate_t";
    var parameters = "hl=en&ie=UTF8&text="+escape(querynokeyword)+"&langpair="+from_lang+"|"+to_lang;
    output = "";
    var xmlhttp=new ActiveXObject("MSXML2.XMLHTTP");
    xmlhttp.onreadystatechange = function(){
      if (xmlhttp.readyState == 4) {
        output = xmlhttp.responseText.match(/<div id=result_box dir="ltr">(.*?)<\/div>/);
        if(output && output[1]) output = output[1];
         else output = "error: No translation found...";
        FARR.setStrValue("statusbar","Google Translate");
        output = pre_results.replace("$$1",output)+"}\\par }";
        FARR.setStrValue("window.richeditmode",output);
      }
    }
    xmlhttp.open("POST",url,true);
    xmlhttp.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
    xmlhttp.setRequestHeader("Content-length", parameters.length);
    xmlhttp.setRequestHeader("Connection", "close");
    xmlhttp.send(parameters);
}

function onInit(c) {
  currentDirectory=c;
}

function onSearchBegin(querykey, explicit, queryraw, querynokeyword) {
  skip_value = 0;
  if(!explicit) {
    if(aliasstr.indexOf(querynokeyword)!=-1) {
      FARR.setState(querykey,1);
      FARR.emitResult(querykey,aliasstr, aliasstr, iconfilename,ALIAS,IMMEDIATE_DISPLAY,300);
      FARR.setState(querykey,0);
    }
    return;
  }
  if(queryraw.match(scriptregex2)) {
    FARR.setStrValue("statusbar","Google Translate");
    FARR.setStrValue("window.richeditmode",output);
    return;
  }
  var fso = new ActiveXObject("Scripting.FileSystemObject");
  var newFile = fso.OpenTextFile(currentDirectory+"\\fscript.rtf", 1, false, -2);
  var newResults = fso.OpenTextFile(currentDirectory+"\\results.rtf", 1, false, -2);
  pre_results = newResults.ReadAll();
  FARR.setStrValue("statusbar","Google Translate");
  FARR.setStrValue("window.richeditmode",newFile.ReadAll());
}

function onRegexSearchMatch(querykey,querynokeyword) {
    var match_reg = querynokeyword.match(scriptregex);
    if(match_reg[1] == "") match_reg[1] = "en";
    if(match_reg[2] == "") match_reg[2] = "de";
    doQuery(querykey,match_reg[3],match_reg[1],match_reg[2]);
}
